## ghc-testsuite 7.4.1

=== testsuite/Makefile ===
TOP = .

# If we're cleaning then we don't want to do all the GHC detection hardwork,
# and we certainly don't want to fail if GHC etc can't be found!
# However, we can't just put this conditional in boilerplate.mk, as
# some of the tests have a "clean" makefile target that relies on GHC_PKG
# being defined.
ifneq "$(MAKECMDGOALS)" "clean"
ifneq "$(MAKECMDGOALS)" "distclean"

include $(TOP)/mk/boilerplate.mk

boot:
	$(MAKE) -C $(TOP)/timeout all

all:
	$(MAKE) -C $(TOP)/tests all

endif
endif

clean distclean maintainer-clean:
	$(MAKE) -C $(TOP)/timeout $@

=== testsuite/tests/Makefile ===
TOP=..
include $(TOP)/mk/boilerplate.mk
include $(TOP)/mk/test.mk

# The libraries that we actually know about. We don't want to test
# extralibs that are in our tree but which we haven't built.
LIBRARIES := $(shell '$(GHC_PKG)' list --simple-output --names-only)

ifeq "$(findstring base,$(LIBRARIES))" ""
$(error base library does not seem to be installed)
endif

# Now find the "tests" directories of those libraries, where they exist
LIBRARY_TEST_PATHS := $(wildcard $(patsubst %, $(TOP)/../libraries/%/tests, $(LIBRARIES)))

# Add tests from packages
RUNTEST_OPTS += $(patsubst %, --rootdir=%, $(LIBRARY_TEST_PATHS))

=== testsuite/timeout/Makefile ===
TOP = ..

# If we're cleaning then we don't want to do all the GHC detection hardwork,
# and we certainly don't want to fail if GHC etc can't be found!
# However, we can't just put this conditional in boilerplate.mk, as
# some of the tests have a "clean" makefile target that relies on GHC_PKG
# being defined.
ifneq "$(MAKECMDGOALS)" "clean"
ifneq "$(MAKECMDGOALS)" "distclean"

include $(TOP)/mk/boilerplate.mk

TIMEOUT_PROGRAM = install-inplace/bin/timeout$(exeext)

PREFIX := $(abspath install-inplace)
$(eval $(call canonicalise,PREFIX))

ifneq "$(GCC)" ""
WITH_GCC = --with-gcc='$(GCC)'
endif

ifeq "$(WINDOWS)" "NO"
# Use a python timeout program, so that we don't have to worry about
# whether or not the compiler we're testing has built the timeout
# program correctly
$(TIMEOUT_PROGRAM): timeout.py
	rm -rf install-inplace
	mkdir install-inplace
	mkdir install-inplace/bin
	cp $< $@.py
	echo '#!/bin/sh' > $@
	echo 'exec "${PYTHON}" $$0.py "$$@"' >> $@
	chmod +x $@
else
# The python timeout program doesn't work on mingw, so we still use the
# Haskell program on Windows
$(TIMEOUT_PROGRAM): timeout.hs
	rm -rf install-inplace
	'$(TEST_HC)' --make Setup
	./Setup configure --with-compiler='$(TEST_HC)' \
	                  --with-hc-pkg='$(GHC_PKG)' \
	                  --with-hsc2hs='$(HSC2HS)' \
	                  $(WITH_GCC) \
	                  --ghc-option=-threaded --prefix='$(PREFIX)'
	./Setup build
	./Setup install
endif

boot all :: calibrate.out $(TIMEOUT_PROGRAM)

calibrate.out:
	$(RM) -f TimeMe.o TimeMe.hi TimeMe TimeMe.exe
	$(PYTHON) calibrate '$(GHC_STAGE1)' > $@
# We use stage 1 to do the calibration, as stage 2 may not exist.
# This isn't necessarily the compiler we'll be running the testsuite
# with, but it's really the performance of the machine that we're
# interested in

endif
endif

clean distclean maintainer-clean:
	-./Setup clean
	$(RM) -rf install-inplace
	$(RM) -f calibrate.out
	$(RM) -f Setup Setup.exe Setup.hi Setup.o

=== testsuite/tests/cabal/Makefile ===
TOP=../..
include $(TOP)/mk/boilerplate.mk
include $(TOP)/mk/test.mk

PKGCONF01=local01.package.conf
LOCAL_GHC_PKG01 = '$(GHC_PKG)' --no-user-package-conf -f $(PKGCONF01)

STRIP_PKGROOT=sed 's/^pkgroot: .*$$/pkgroot: /'

# a bunch of tests for ghc-pkg
ghcpkg01 :
	@rm -rf $(PKGCONF01)
	$(LOCAL_GHC_PKG01) init $(PKGCONF01)
	$(LOCAL_GHC_PKG01) list
	$(LOCAL_GHC_PKG01) register --force test.pkg 2>/dev/null
	$(LOCAL_GHC_PKG01) describe testpkg         | $(STRIP_PKGROOT)
	$(LOCAL_GHC_PKG01) describe testpkg-1.2.3.4 | $(STRIP_PKGROOT)
	$(LOCAL_GHC_PKG01) field testpkg-1.2.3.4 import-dirs

	@: # test2.pkg is a later version of testpkg-1.2.3.4
	$(LOCAL_GHC_PKG01) register --force test2.pkg 2>/dev/null
	$(LOCAL_GHC_PKG01) list
	$(LOCAL_GHC_PKG01) describe testpkg-2.0 | $(STRIP_PKGROOT)
	$(LOCAL_GHC_PKG01) describe testpkg-*   | $(STRIP_PKGROOT)
	$(LOCAL_GHC_PKG01) field testpkg-* version

	@: # test hiding/exposing
	$(LOCAL_GHC_PKG01) hide testpkg-1.2.3.4
	$(LOCAL_GHC_PKG01) field testpkg-1.2.3.4 exposed | grep False
	$(LOCAL_GHC_PKG01) expose testpkg-2.0
	$(LOCAL_GHC_PKG01) field testpkg-2.0 exposed | grep True
	$(LOCAL_GHC_PKG01) hide testpkg-*
	$(LOCAL_GHC_PKG01) field testpkg-* exposed

	@: # test3.pkg  depends on testpkg-2.0
	$(LOCAL_GHC_PKG01) register test3.pkg

	@: # unregistering testpkg-2.0 should fail now, testpkg-3.0 depends on it
	if $(LOCAL_GHC_PKG01) unregister testpkg-2.0; then false; else true; fi

	$(LOCAL_GHC_PKG01) unregister testpkg-3.0

	$(LOCAL_GHC_PKG01) unregister testpkg-2.0
	$(LOCAL_GHC_PKG01) describe testpkg | $(STRIP_PKGROOT)
	$(LOCAL_GHC_PKG01) unregister testpkg-*
	$(LOCAL_GHC_PKG01) list

	@: # registering test3.pkg should fail now, its dependency has gone
	if $(LOCAL_GHC_PKG01) register test3.pkg; then false; else true; fi

PKGCONF03=local03.package.conf
LOCAL_GHC_PKG03 = '$(GHC_PKG)' --no-user-package-conf -f $(PKGCONF03)

ghcpkg03 :
	@rm -rf $(PKGCONF03)
	$(LOCAL_GHC_PKG03) init $(PKGCONF03)
	@: # update should hide conflicting packages
	$(LOCAL_GHC_PKG03) register --force test.pkg
	$(LOCAL_GHC_PKG03) register --force test2.pkg

	@: # test4.pkg depends on testpkg-2.0, which conflicts with testpkg-1.2.3.4,
	@: # ghc-pkg will happily register it now (it didn't in GHC 6.4)
	$(LOCAL_GHC_PKG03) register test4.pkg
	$(LOCAL_GHC_PKG03) update test4.pkg

	@: # and another update of test.pkg will now hide dep-2.0
	$(LOCAL_GHC_PKG03) update --force test.pkg

PKGCONF04=local04.package.conf
LOCAL_GHC_PKG04 = '$(GHC_PKG)' --no-user-package-conf -f $(PKGCONF04)

# Test that importing a module exposed by two packages reports a conflict
ghcpkg04 :
	rm -rf $(PKGCONF04)
	$(LOCAL_GHC_PKG04) init $(PKGCONF04)
	$(LOCAL_GHC_PKG04) register --force test.pkg >/dev/null 2>&1 
	$(LOCAL_GHC_PKG04) update --force test5.pkg >/dev/null 2>&1 
	$(LOCAL_GHC_PKG04) expose testpkg-1.2.3.4  >/dev/null 2>&1
	@: # testpkg-1.2.3.4 and newtestpkg-2.0 are both exposed now
	'$(TEST_HC)' $(TEST_HC_OPTS) -package-conf $(PKGCONF04) -c ghcpkg04.hs || true

# Test stacking of package.confs (also #2441)
PKGCONF05a=local05a.package.conf
PKGCONF05b=local05b.package.conf
LOCAL_GHC_PKG05a = '$(GHC_PKG)' --no-user-package-conf -f $(PKGCONF05a)
LOCAL_GHC_PKG05b = '$(GHC_PKG)' --no-user-package-conf -f $(PKGCONF05a) -f $(PKGCONF05b)

ghcpkg05 :
	rm -rf $(PKGCONF05a) $(PKGCONF05b)
	$(LOCAL_GHC_PKG05a) init $(PKGCONF05a)
	$(LOCAL_GHC_PKG05b) init $(PKGCONF05b)
	$(LOCAL_GHC_PKG05a) register --force test2.pkg >/dev/null 2>&1 
	$(LOCAL_GHC_PKG05b) register --force test3.pkg >/dev/null 2>&1 
	$(LOCAL_GHC_PKG05b) check || true
	$(LOCAL_GHC_PKG05b) list
	$(LOCAL_GHC_PKG05b) expose testpkg-2.0
	$(LOCAL_GHC_PKG05b) hide   testpkg-2.0
	if $(LOCAL_GHC_PKG05b) unregister testpkg-2.0; then false; else true; fi
	$(LOCAL_GHC_PKG05b) unregister testpkg-3.0
	$(LOCAL_GHC_PKG05b) unregister testpkg-2.0

# Test for #2330: reject duplicate dependencies
PKGCONF06=local06.package.conf
LOCAL_GHC_PKG06 = '$(GHC_PKG)' --no-user-package-conf -f $(PKGCONF06)

ghcpkg06 :
	rm -rf $(PKGCONF06)
	$(LOCAL_GHC_PKG06) init $(PKGCONF06)
	$(LOCAL_GHC_PKG06) register --force test.pkg >/dev/null 2>&1 
	if $(LOCAL_GHC_PKG06) register testdup.pkg; then false else true; fi
	$(LOCAL_GHC_PKG06) register --force testdup.pkg

PKGCONF1750=local1750.package.conf
LOCAL_GHC_PKG1750 = '$(GHC_PKG)' --no-user-package-conf -f $(PKGCONF1750)

1750:
	rm -rf $(PKGCONF1750) 1750.hs 1750.o 1750.hi 1750.out
	$(LOCAL_GHC_PKG1750) init $(PKGCONF1750)
	$(LOCAL_GHC_PKG1750) register --force 1750A.pkg >1750.out 2>&1
	$(LOCAL_GHC_PKG1750) register --force 1750B.pkg >1750.out 2>&1
	GHC_PACKAGE_PATH=$(PKGCONF1750) '$(GHC_PKG)' --no-user-package-conf list
# GHC_PACKAGE_PATH trick is to make this work with 6.8.2 which doesn't have
# the patch "Change the command-line semantics for query commands" to
# ghc-pkg
	echo "main = return ()" >1750.hs
	'$(TEST_HC)' $(TEST_HC_OPTS) -package-conf $(PKGCONF1750) -package 1750A 1750.hs || true

PKGCONFSHADOW1=localshadow1.package.conf
PKGCONFSHADOW2=localshadow2.package.conf
LOCAL_GHC_PKGSHADOW1 = '$(GHC_PKG)' --no-user-package-conf -f $(PKGCONFSHADOW1)
LOCAL_GHC_PKGSHADOW2 = '$(GHC_PKG)' --no-user-package-conf -f $(PKGCONFSHADOW2)
LOCAL_GHC_PKGSHADOW3 = '$(GHC_PKG)' --no-user-package-conf -f $(PKGCONFSHADOW1) -f $(PKGCONFSHADOW2)

# Test package shadowing behaviour.
#
#     localshadow1.package.conf:  shadowdep-1-XXX <- shadow-1-XXX
#     localshadow2.package.conf:                     shadow-1-YYY
# 
# shadow-1-XXX will be shadowed by shadow-1-YYY, thus invalidating
# shadowdep-1-XXX.
shadow:
	rm -rf $(PKGCONFSHADOW1) $(PKGCONFSHADOW2) shadow.hs shadow.o shadow.hi shadow.out shadow.hs shadow.hi
	$(LOCAL_GHC_PKGSHADOW1) init $(PKGCONFSHADOW1)
	$(LOCAL_GHC_PKGSHADOW2) init $(PKGCONFSHADOW2)
	$(LOCAL_GHC_PKGSHADOW1) register -v0 --force shadow1.pkg
	$(LOCAL_GHC_PKGSHADOW1) register -v0 --force shadow2.pkg
	$(LOCAL_GHC_PKGSHADOW2) register -v0 --force shadow3.pkg
	$(LOCAL_GHC_PKGSHADOW3) list
	echo "main = return ()" >shadow.hs
# 
# In this test, shadow-1-XXX is shadowed by shadow-1-YYY, which causes
# shadowdep-1-XXX to be unavailable:
#
	@echo "should FAIL:"
	'$(TEST_HC)' $(TEST_HC_OPTS) -package-conf $(PKGCONFSHADOW1) -package-conf $(PKGCONFSHADOW2) -package shadowdep -c shadow.hs -fno-code || true
# 
# Reversing the order of the package.conf files should fix the problem:
#
	@echo "should SUCCEED:"
	'$(TEST_HC)' $(TEST_HC_OPTS) -package-conf $(PKGCONFSHADOW2) -package-conf $(PKGCONFSHADOW1) -package shadowdep -c shadow.hs -fno-code || true
#
# We can also fix the problem by using an explicit -package-id flag to
# specify a package we really want to use:
#
	@echo "should SUCCEED:"
	'$(TEST_HC)' $(TEST_HC_OPTS) -package-conf $(PKGCONFSHADOW1) -package-conf $(PKGCONFSHADOW2) -package-id shadowdep-1-XXX -c shadow.hs -fno-code


# -----------------------------------------------------------------------------
# Try piping the output of "ghc-pkg describe" into "ghc-pkg update" for
# every package we know about.  This is for testing the pretty printing/parsing
# of InstalledPackageInfo.

PACKAGE_CONF_ghcpkg02 = package.conf.ghcpkg02
GHC_PKG_ghcpkg02 = '$(GHC_PKG)' --no-user-package-conf --global-conf=$(PACKAGE_CONF_ghcpkg02)

ghcpkg02:
	rm -rf $(PACKAGE_CONF_ghcpkg02)
	$(GHC_PKG_ghcpkg02) init $(PACKAGE_CONF_ghcpkg02)
	set -e; \
	for i in `$(GHC_PKG) list --global --simple-output -v0`; do \
		echo Updating $$i; \
		$(GHC_PKG) describe --global $$i | $(GHC_PKG_ghcpkg02) update --global --force -; \
	done

=== testsuite/tests/driver/Makefile ===
TOP=../..
include $(TOP)/mk/boilerplate.mk
include $(TOP)/mk/test.mk

# A set of driver tests

# Things to test:
#
#  - one-shot vs. --make
#  - hierarchical vs. flat
#  - -odir vs. no -odir
#  - -hidir vs. no -hidir
#  - root module vs. found modules

OBJSUFFIX = .o

# -fforce-recomp makes lots of driver tests trivially pass, so we
# filter it out from $(TEST_HC_OPTS).
TEST_HC_OPTS_NO_RECOMP = $(filter-out -fforce-recomp,$(TEST_HC_OPTS))

# -----------------------------------------------------------------------------
# One-shot compilations, non-hierarchical modules

test011:
	$(RM) A011.hi
	$(RM) A011$(OBJSUFFIX)
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -c A011.hs
	test -f A011.hi
	test -f A011$(OBJSUFFIX)

# test -o
test012:
	$(RM) A012.hi
	$(RM) A012$(OBJSUFFIX)oo
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -c A012.hs -o A012$(OBJSUFFIX)oo
	test -f A012$(OBJSUFFIX)oo

# test -ohi
test013:
	$(RM) A013.xhi
	$(RM) A013$(OBJSUFFIX)
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -c A013.hs -ohi A013.xhi
	test -f A013.xhi

# test -odir
test014:
	$(RM) -f A014.hi
	$(RM) -rf obj014
	mkdir obj014
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -c A014.hs -odir obj014
	test -f obj014/A014$(OBJSUFFIX)
	test -f A014.hi

# test -hidir
test015:
	$(RM) -f A015$(OBJSUFFIX)
	$(RM) -rf hi015
	mkdir hi015
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -c A015.hs -hidir hi015
	test -f A015$(OBJSUFFIX)
	test -f hi015/A015.hi

# test stub generation
test016:
	$(RM) F016.hi F016$(OBJSUFFIX) F016_stub.h
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -c F016.hs
	test -f F016_stub.h

# test -stubdir (filename differs from module name)
test017:
	$(RM) F017.hi F017$(OBJSUFFIX)
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -c F017.hs -stubdir stub017
	test -f stub017/TestStub017_stub.h

# test -odir with stubs (filename differs from module name)
test018:
	$(RM) -f F018.hi F018$(OBJSUFFIX) F018_stub.h
	$(RM) -rf obj018
	mkdir obj018
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -c F018.hs -odir obj018

# test for bug #3093
test018a:
	$(RM) -f F018a.hi F018a_stub.h *.obj.018
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -c F018a.hs -osuf obj.018
	test -f F018a.obj.018

# test -outputdir
test019:
	$(RM) -rf out019
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -c F019.hs -outputdir out019
	test -f out019/TestStub019.hi
	test -f out019/TestStub019_stub.h

# -----------------------------------------------------------------------------
# One-shot compilation, hierarchical modules

test021:
	$(RM) B021/C.hi
	$(RM) B021/C$(OBJSUFFIX)
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -c B021/C.hs
	test -f B021/C.hi
	test -f B021/C$(OBJSUFFIX)

# test -o
test022:
	$(RM) B022/C.hi
	$(RM) B022/C$(OBJSUFFIX)oo
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -c B022/C.hs -o B022/C$(OBJSUFFIX)oo
	test -f B022/C$(OBJSUFFIX)oo

# test -ohi
test023:
	$(RM) B023/C.xhi
	$(RM) B023/C$(OBJSUFFIX)
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -c B023/C.hs -ohi B023/C.xhi
	test -f B023/C.xhi

# test -odir
test024:
	$(RM) -f B024/C.hi
	$(RM) -rf obj024
	mkdir obj024
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -c B024/C.hs -odir obj024
	test -f obj024/B024/C$(OBJSUFFIX)

# test -odir with non-Haskell compilation
test024a:
	$(RM) -rf B024a
	$(RM) -rf obj024a
	mkdir B024a
	mkdir obj024a
	echo >B024a/stub.c
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -c B024a/stub.c -odir obj024a
	test -f obj024a/B024a/stub$(OBJSUFFIX)

# test -hidir
test025:
	$(RM) -rf hi025
	mkdir hi025
	$(RM) B025/C$(OBJSUFFIX)
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -c B025/C.hs -hidir hi025
	test -f hi025/B025/C.hi

# This is a hierarchical module that lives in a subdirectory.
test026:
	$(RM) d026/P/Q.hi
	$(RM) d026/P/Q$(OBJSUFFIX)
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -c d026/P/Q.hs
	test -f d026/P/Q.hi
	test -f d026/P/Q$(OBJSUFFIX)

# test stub generation
# -fvia-C, because we want to check that the .hc file can #include the stub.h
test027:
	$(RM) B027/F.hi B027/F$(OBJSUFFIX) B027/F_stub.h
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -c B027/F.hs -fno-warn-deprecated-flags -fvia-C
	test -f B027/F_stub.h

# test -stubdir
# -fvia-C, because we want to check that the .hc file can #include the stub.h
test028:
	$(RM) B028/F.hi B028/F$(OBJSUFFIX)
	$(RM) stub028/B028/F_stub.h
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -c B028/F.hs -stubdir stub028 -fno-warn-deprecated-flags -fvia-C
	test -f stub028/B028/F_stub.h

# -----------------------------------------------------------------------------
# Compilation-manager compilations, flat modules

test031:
	$(RM) A031.hi
	$(RM) A031$(OBJSUFFIX)
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -v0 --make A031.hs
	test -f A031.hi
	test -f A031$(OBJSUFFIX)

# test -odir
test032:
	$(RM) A032.hi
	$(RM) -rf obj032
	mkdir obj032
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -v0 --make A032.hs -odir obj032
	test -f obj032/A032$(OBJSUFFIX)

# test -hidir
test033:
	$(RM) -rf hi033
	$(RM) A033$(OBJSUFFIX)
	mkdir hi033
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -v0 --make A033.hs -hidir hi033
	test -f hi033/A033.hi

# test stub generation
test034:
	$(RM) F034.hi F034$(OBJSUFFIX) F034_stub.h
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -v0 --make F034.hs
	test -f F034_stub.h

# test -stubdir (filename differs from module name)
test035:
	$(RM) F035.hi F$(OBJSUFFIX) stub035/Stubs_stub.h
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -v0 --make F035.hs -stubdir stub035
	test -f stub035/TestStub035_stub.h

# -----------------------------------------------------------------------------
# Compilation-manager compilations, hierarchical modules

test041:
	$(RM) B041/C.hi
	$(RM) B041/C$(OBJSUFFIX)
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -v0 --make B041/C.hs
	test -f B041/C.hi
	test -f B041/C$(OBJSUFFIX)

# test -odir
test042:
	$(RM) -rf obj042
	mkdir obj042
	$(RM) B042/C.hi
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -v0 --make B042/C.hs -odir obj042
	test -f obj042/B042/C$(OBJSUFFIX)

# test -hidir
test043:
	$(RM) -f B043/C$(OBJSUFFIX)
	$(RM) -rf hi043
	mkdir hi043
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -v0 --make B043/C.hs -hidir hi043
	test -f hi043/B043/C.hi

# test stub generation
test044:
	$(RM) B044/F.hi B044/F$(OBJSUFFIX) B044/F_stub.h
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -v0 --make B044/F.hs
	test -f B044/F_stub.h

# test -stubdir
test045:
	$(RM) B045/F.hi B045/F$(OBJSUFFIX)
	$(RM) stub045/B045/F_stub.h
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -v0 --make B045/F.hs -stubdir stub045
	test -f stub045/B045/F_stub.h

# -----------------------------------------------------------------------------
# Compilation-manager compilations, hierarchical modules, non-root modules

test051:
	$(RM) d051_2/R/S.hi
	$(RM) d051_2/R/S$(OBJSUFFIX)
	$(RM) d051_1/P/Q.hi
	$(RM) d051_1/P/Q$(OBJSUFFIX)
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -v0 --make -id051_1 -id051_2 R.S
	test -f d051_2/R/S.hi
	test -f d051_2/R/S$(OBJSUFFIX)
	test -f d051_1/P/Q.hi
	test -f d051_1/P/Q$(OBJSUFFIX)

# test -odir
test052:
	$(RM) d052_2/R/S.hi
	$(RM) d052_1/P/Q.hi
	$(RM) -rf obj052
	mkdir obj052
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -v0 --make -id052_1 -id052_2 -odir obj052 R.S
	test -f d052_2/R/S.hi
	test -f obj052/R/S$(OBJSUFFIX)
	test -f d052_1/P/Q.hi
	test -f obj052/P/Q$(OBJSUFFIX)

# test -hidir
test053:
	$(RM) hi053/R/S.hi
	$(RM) d053_2/R/S$(OBJSUFFIX)
	$(RM) hi053/P/Q.hi
	$(RM) d053_1/P/Q$(OBJSUFFIX)
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -v0 --make -id053_1 -id053_2 -hidir hi053 R.S
	test -f hi053/R/S.hi
	test -f d053_2/R/S$(OBJSUFFIX)
	test -f hi053/P/Q.hi
	test -f d053_1/P/Q$(OBJSUFFIX)

# -----------------------------------------------------------------------------
# Other tests

# Test that -keep-s-files works with --make and -fvia-C
test061a:
	$(RM) A061a.hi A061a$(OBJSUFFIX) A061a.s
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -v0 --make -keep-s-files -fno-warn-deprecated-flags -fvia-C A061a.hs
	test -f A061a.s

# Test that -keep-s-files works without --make
test061b:
	$(RM) A061b.hi A061b$(OBJSUFFIX) A061b.s
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -c -keep-s-files -fno-warn-deprecated-flags -fvia-C A061b.hs
	test -f A061b.s

# Test that -main-is works with --make
test062a:
	$(RM) Hello062a.hs Hello062a.hi Hello062a$(OBJSUFFIX) Hello062a.hc hello062a
	echo "module Hello062a where { hello062a = putStrLn \"ok\" }" >Hello062a.hs
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -v0 --make -main-is Hello062a.hello062a Hello062a -o hello062a
	./hello062a
test062b:
	$(RM) Hello062b.hs Hello062b.hi Hello062b$(OBJSUFFIX) Hello062b.hc hello062b
	echo "module Hello062b where { main = putStrLn \"ok\" }" >Hello062b.hs
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -v0 --make -main-is Hello062b Hello062b -o hello062b
	./hello062b
test062c:
	$(RM) Hello062c.hs Hello062c.hi Hello062c$(OBJSUFFIX) Hello062c.hc hello062c
	echo "module Main (hello062c) where { hello062c = putStrLn \"ok\" }" >Hello062c.hs
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -v0 --make -main-is hello062c Hello062c.hs -o hello062c
	./hello062c
test062d:
	$(RM) -rf B062d
	$(RM) hello062d
	mkdir B062d
	echo "module B062d.Hello062d (hello062d) where { hello062d = putStrLn \"ok\" }" >B062d/Hello062d.hs
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -v0 --make -main-is B062d.Hello062d.hello062d B062d/Hello062d.hs -o hello062d
	./hello062d
test062e:
	$(RM) -rf B062e
	$(RM) Hello062e.hc hello062e
	mkdir B062e
	echo "module B062e.Hello062e (main) where { main = putStrLn \"ok\" }" >B062e/Hello062e.hs
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -v0 --make -main-is B062e.Hello062e B062e/Hello062e.hs -o hello062e
	./hello062e

# Test that -i deletes the list of search paths.
# The compilation will fail, but we ignore the failure and just
# compare the output, because make might give us a different exit code.
test063:
	$(RM) A063.hi A063$(OBJSUFFIX) A063.hc D063.hi D063$(OBJSUFFIX) D063.hc
	-"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) --make -i -v0 D063.hs

# Test -E
test064:
	$(RM) A064.hi A064.hspp
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -E A064.hs
	test -f A064.hspp

# Test -E/-cpp
test065:
	$(RM) A065.hi A065.hspp
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -E -cpp A065.hs
	test -f A065.hspp

# Test -E/-o
test066:
	$(RM) A066.hi A066.tmp
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -E A066.hs -o A066.tmp
	test -f A066.tmp

# Test -E/-cpp/-o
test067:
	$(RM) A067.hi A067.tmp
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -cpp -E A067.hs -o A067.tmp
	test -f A067.tmp

# Test -S
test070:
	$(RM) A070.hi A070.s
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -S A070.hs
	test -f A070.s

# Test -S/-o
test071:
	$(RM) A071.hi A071.tmp
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -S A071.hs -o A071.tmp
	test -f A071.tmp


# Tests for #2248, -o and .exe

define test081
$(RM) $(1).hs $(1).hi $(1)$(OBJSUFFIX) $(1).hc $(1)$(exeext)
echo "module Main where { main = putStrLn \"ok\" }" >$(1).hs
"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) --make -v0 $(1).hs
test -f $(1)$(exeext)
endef

test081a:
	$(call test081, Test_081a)
test081b:
	$(call test081, Test.081b)

# -----------------------------------------------------------------------------
# --make tests

# Test for overlap between home module and package module
test100:
	$(RM) overlap/List.hi overlap/List.o
	$(RM) overlap/Overlap.hi overlap/Overlap.o
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -v0 --make -ioverlap Overlap

# -----------------------------------------------------------------------------
# dependency-generation tests

DEPFILE200 = depend200

# Test that we can create a dependency file, and that we can
# modify an existing dependency file.
test200:
	$(RM) $(DEPFILE200)
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -M -dep-makefile $(DEPFILE200) D200
	test -f $(DEPFILE200)
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -M -dep-makefile $(DEPFILE200) D200 B200.C A200
	test -f $(DEPFILE200)
	"$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -M -dep-makefile $(DEPFILE200) D200.hs B200/C.hs A200.hs
	test -f $(DEPFILE200)

# -----------------------------------------------------------------------------

2566::
	if "$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -c foo2566.bar; then false else true; fi

.PHONY: mode001
# We use
#     sed '2,$$d'
# rather than
#     head -1
# as the latter gives

=== testsuite/tests/dynlibs/Makefile ===
TOP=../..
include $(TOP)/mk/boilerplate.mk
include $(TOP)/mk/test.mk

.PHONY: T3807
T3807:
	$(RM) T3807Export_stub.c T3807Export_stub.h T3807Export_stub.o
	$(RM) T3807Export.o T3807Export.hi
	$(RM) T3807-export.o T3807-load.o
	$(RM) T3807test.so
	$(RM) T3807-load
	'$(TEST_HC)' $(filter-out -rtsopts,$(TEST_HC_OPTS)) -v0 --make -dynamic -fPIC -shared T3807Export.hs T3807-export.c -o T3807test.so -lHSrts-ghc`'$(TEST_HC)' $(TEST_HC_OPTS) --numeric-version` -rtsopts
	'$(TEST_HC)' $(filter-out -rtsopts,$(TEST_HC_OPTS)) -no-auto-link-packages -no-hs-main T3807-load.c -o T3807-load -ldl
	./T3807-load

.PHONY: T4464
T4464:
	$(RM) T4464B.o T4464C.o T4464H.hi T4464H.o
	$(RM) T4464H_stub.c T4464H_stub.h T4464H_stub.o
	$(RM) HS4464.dll HS4464.dll.a t4464.exe
	'$(TEST_HC)' $(TEST_HC_OPTS) -v0 -shared T4464H.hs T4464B.c -optc-DRTSOPTS=RtsOptsSafeOnly -o HS4464.dll
	'$(TEST_HC)' $(TEST_HC_OPTS) -v0 T4464C.c HS4464.dll.a -o t4464.exe -no-hs-main
	-./t4464.exe
	echo "====="
	echo "=====" >&2
	$(RM) T4464B.o T4464C.o T4464H.hi T4464H.o
	$(RM) T4464H_stub.c T4464H_stub.h T4464H_stub.o
	$(RM) HS4464.dll HS4464.dll.a t4464.exe
	'$(TEST_HC)' $(TEST_HC_OPTS) -v0 -shared T4464H.hs T4464B.c  -optc-DRTSOPTS=RtsOptsAll -o HS4464.dll
	'$(TEST_HC)' $(TEST_HC_OPTS) -v0 T4464C.c HS4464.dll.a -o t4464.exe -no-hs-main
	./t4464.exe

.PHONY: T5373
T5373:
	'$(TEST_HC)' $(filter-out -rtsopts,$(TEST_HC_OPTS)) -v0 -dynamic --make T5373A
	'$(TEST_HC)' $(filter-out -rtsopts,$(TEST_HC_OPTS)) -v0 -dynamic --make T5373B -rtsopts
	'$(TEST_HC)' $(filter-out -rtsopts,$(TEST_HC_OPTS)) -v0 -dynamic --make T5373C -rtsopts=some
	'$(TEST_HC)' $(filter-out -rtsopts,$(TEST_HC_OPTS)) -v0 -dynamic --make T5373D -rtsopts=none
	-./T5373A +RTS -c 2>&1 | grep disabled
	-./T5373B +RTS -c 2>&1 | grep disabled
	-./T5373C +RTS -c 2>&1 | grep disabled
	-./T5373D +RTS -c 2>&1 | grep disabled

=== testsuite/tests/plugins/Makefile ===
TOP=../..
include $(TOP)/mk/boilerplate.mk
include $(TOP)/mk/test.mk

.PHONY: plugins01 clean

plugins01:
	# This test is extremely fragile because any change in the output of the following
	# commands invalidates the output of the run.  In fact, we really want to ignore the
	# output resulting from building the simple-plugin, and only look at a few lines of
	# the output of the call to the TEST_HC (probably just the last 2).
	#
	# Suggestions to make this better gratefully recieved.
	(cd simple-plugin; make package)
	@$(RM) plugins01.hi plugins01.o
	"$(TEST_HC)" $(HC_OPTS) --make -v0 plugins01.hs -package-conf simple-plugin/local.package.conf -fplugin Simple.Plugin -fplugin-opt Simple.Plugin:Irrelevant_Option -package simple-plugin
	./plugins01

clean:
	cd simple-plugin && make clean

=== testsuite/tests/rts/Makefile ===
TOP=../..
include $(TOP)/mk/boilerplate.mk
include $(TOP)/mk/test.mk

outofmem-prep::
	'$(TEST_HC)' $(TEST_HC_OPTS) -v0 --make -fforce-recomp outofmem.hs -o outofmem

outofmem::
	@$(MAKE) outofmem-prep
	@ulimit -v 10000000 2>/dev/null; ./outofmem || echo "exit($$?)"

outofmem2-prep::
	'$(TEST_HC)' $(TEST_HC_OPTS) -v0 -rtsopts --make -fforce-recomp outofmem2.hs -o outofmem2

outofmem2::
	@$(MAKE) outofmem2-prep
	@ulimit -v 1000000 2>/dev/null; ./outofmem2 +RTS -M5m -RTS || echo "exit($$?)"

T2615-prep:
	$(RM) libfoo_T2615.so
	'$(TEST_HC)' $(TEST_HC_OPTS) -fPIC -c libfoo_T2615.c -o libfoo_T2615.o
	'$(TEST_HC)' $(TEST_HC_OPTS) -shared -no-auto-link-packages libfoo_T2615.o -o libfoo_T2615.so

.PHONY: T4059
T4059:
	$(RM) T4059_c.o T4059.o T4059.hi
	'$(TEST_HC)' $(TEST_HC_OPTS) -v0 --make T4059 T4059_c.c
	./T4059

exec_signals-prep:
	$(CC) -o exec_signals_child exec_signals_child.c
	$(CC) -o exec_signals_prepare exec_signals_prepare.c

.PHONY: 4850
4850:
	$(RM) 4850.o 4850.hi 4850$(exeext)
	"$(TEST_HC)" $(TEST_HC_OPTS) -v0 -rtsopts -debug -threaded --make 4850
	./4850 +RTS -s 2>&1 | grep Task | wc -l | tr -d ' '

.PHONY: T5423
T5423:
	$(RM) T5423_cmm.o T5423.o T5423.hi T5423$(exeext)
	"$(TEST_HC)" $(TEST_HC_OPTS) -v0 -c T5423_cmm.cmm
	"$(TEST_HC)" $(TEST_HC_OPTS) -v0 -c T5423.hs
	"$(TEST_HC)" $(TEST_HC_OPTS) -v0 T5423.o T5423_cmm.o -o T5423$(exeext)
	./T5423

=== testsuite/tests/cabal/cabal01/Makefile ===
TOP=../../..
include $(TOP)/mk/boilerplate.mk
include $(TOP)/mk/test.mk

clean:
	rm -rf setup a.out dist/build/testA
	rm -rf ,tmp dist ,tmp2
	find . -name "*.o" |xargs rm -f
	find . -name "*.hi" |xargs rm -f
	rm -fr install-tmp
	rm -fr install
	rm -f .setup-config .installed-pkg-config
	rm -rf local.db

# We use the global package database as there's no easy way to tell
# ghc-pkg (via Cabal) to use one in ., and the global one at least
# won't affect the installed GHC and is more likely to work

PREFIX := $(abspath install)
$(eval $(call canonicalise,PREFIX))

cabal01:
	$(MAKE) clean
	'$(TEST_HC)' --make -o setup Setup.lhs -v0

	'$(GHC_PKG)' init local.db
	./setup configure -v0 --prefix=$(PREFIX) --with-compiler='$(TEST_HC)' --ghc-options='$(TEST_HC_OPTS)' --with-hc-pkg='$(GHC_PKG)' --package-db=local.db $(PROF)
	./setup build -v0
	./setup copy -v0
	echo install1:
	ls -1 install
	rm -r install
#	install w/ register!
	./setup install -v0
	echo install2:
	ls -1 install
	./setup sdist -v0
	echo dist:
	ls -1 dist
	if [ "$(CLEANUP)" != "" ]; then $(MAKE) clean; fi

=== testsuite/tests/cabal/cabal04/Makefile ===
TOP=../../..
include $(TOP)/mk/boilerplate.mk
include $(TOP)/mk/test.mk

SETUP=./Setup -v0

# This tests that we can build a Cabal package that uses TH with both
# profiling and dynamic linking. (#3604)

cabal04:
	$(MAKE) clean
	'$(TEST_HC)' -v0 --make Setup
	$(SETUP) clean
	$(SETUP) configure --with-ghc='$(TEST_HC)' --ghc-options='$(TEST_HC_OPTS)' $(PROF) $(DYN)
	$(SETUP) build 2> err
	! grep -v "Creating library file" err
ifneq "$(CLEANUP)" ""
	$(MAKE) clean
endif

clean :
	$(RM) -r *.o *.hi dist Setup$(exeext) err

=== testsuite/tests/deriving/should_fail/Makefile ===
TOP=../../..
include $(TOP)/mk/boilerplate.mk
include $(TOP)/mk/test.mk

drvfail016:
	$(RM) -f drvfail016.hi-boot drvfail016.o-boot
	'$(TEST_HC)' $(TEST_HC_OPTS) -XGeneralizedNewtypeDeriving -c drvfail016.hs-boot; echo $$?

=== testsuite/tests/driver/1372/Makefile ===
TOP=../../..
include $(TOP)/mk/boilerplate.mk
include $(TOP)/mk/test.mk

# -fforce-recomp makes lots of driver tests trivially pass, so we
# filter it out from $(TEST_HC_OPTS).
TEST_HC_OPTS_NO_RECOMP = $(filter-out -fforce-recomp,$(TEST_HC_OPTS))

LOCAL_PKGCONF=local.package.conf

clean:
	rm -f p1/setup p1/Setup.o p1/Setup.hi
	rm -f p2/setup p2/Setup.o p2/Setup.hi
	rm -rf p1/dist p2/dist
	rm -f *.o *.hi
	rm -f clean.out prep.out
	rm -f p1/A.hs
	rm -f $(LOCAL_PKGCONF)

1372:
	$(MAKE) clean
	$(MAKE) prep
# This should recompile Main.hs, because A in package p1 has changed
# and recompiling Main.hs will now fail.
	-cd p2 && ./setup build -v0
	$(MAKE) clean

prep:
	echo "[]" >$(LOCAL_PKGCONF)
	cp p1/A1.hs p1/A.hs
	$(MAKE) prep.p1
	$(MAKE) prep.p2
	cp p1/A2.hs p1/A.hs
	cd p1 && ./setup build -v0

prep.%:
	cd $* && "$(TEST_HC)" $(TEST_HC_OPTS_NO_RECOMP) -v0 --make -o setup Setup.hs
	cd $* && ./setup configure -v0 --with-compiler="$(TEST_HC)" --with-hc-pkg="$(GHC_PKG)" --package-db=../$(LOCAL_PKGCONF)
	cd $* && ./setup build -v0
	cd $* && ./setup register -v0 --inplace

=== debian/changelog ===
ghc-testsuite (7.4.1-3) unstable; urgency=low

  * Only depend on ghc-dynamic on i386 and amd64 

 -- Joachim Breitner <nomeata@debian.org>  Tue, 14 Feb 2012 09:27:23 +0100

ghc-testsuite (7.4.1-2) unstable; urgency=low

  * Build-Depend on python

 -- Joachim Breitner <nomeata@debian.org>  Mon, 13 Feb 2012 22:13:45 +0100

ghc-testsuite (7.4.1-1) unstable; urgency=low

  * Fix watch URL

 -- Joachim Breitner <nomeata@debian.org>  Mon, 13 Feb 2012 20:56:31 +0100

=== debian/control ===
Source: ghc-testsuite
Section: haskell
Priority: extra
Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
Uploaders: Joachim Breitner <nomeata@debian.org>
Build-Depends:
 python,
 debhelper (>= 8.0.0),
 ghc (>= 7.4.1),
 ghc (<< 7.4.1+),
 ghc-prof,
 ghc-dynamic [i386 amd64],
 libghc-quickcheck1-dev,
 libghc-quickcheck1-prof,
 libghc-vector-dev,
 libghc-vector-prof,
 libghc-mtl-dev,
 libghc-mtl-prof,
 libghc-parallel-dev,
 libghc-parallel-prof,
 libghc-regex-compat-dev,
 libghc-regex-compat-prof,
 libghc-regex-posix-dev,
 libghc-regex-posix-prof,
 libghc-syb-dev,
 libghc-syb-prof,
 libghc-utf8-string-dev,
 libghc-utf8-string-prof,
 libghc-parsec3-dev,
 libghc-parsec3-prof,
Standards-Version: 3.9.2
Homepage: http://hackage.haskell.org/trac/ghc/wiki/Building/RunningTests
Vcs-Darcs: http://darcs.debian.org/pkg-haskell/ghc-testsuite
Vcs-Browser: http://darcs.debian.org/cgi-bin/darcsweb.cgi?r=pkg-haskell/ghc-testsuite


Package: ghc-testsuite
Architecture: any
Depends: ${misc:Depends}
Description: GHC testsuite results
 This package is just a container for the results of the GHC testsuite. There
 is usually no point in installing this package.

## ghc-testsuite 7.4.2

=== debian/changelog ===
ghc-testsuite (7.4.2-0ubuntu1) quantal; urgency=low

  * New upstream release for GHC 7.4.2

 -- Iain Lane <iain@orangesquash.org.uk>  Wed, 03 Oct 2012 15:00:31 +0100

=== debian/control ===
--- 
+++ 
@@ -6,8 +6,8 @@
 Build-Depends:
  python,
  debhelper (>= 8.0.0),
- ghc (>= 7.4.1),
- ghc (<< 7.4.1+),
+ ghc (>= 7.4.2),
+ ghc (<< 7.4.2+),
  ghc-prof,
  ghc-dynamic [i386 amd64],
  libghc-quickcheck1-dev,

## ghc-testsuite 7.6.3

=== testsuite/Makefile ===
--- 
+++ 
@@ -7,6 +7,7 @@
 # being defined.
 ifneq "$(MAKECMDGOALS)" "clean"
 ifneq "$(MAKECMDGOALS)" "distclean"
+ifneq "$(MAKECMDGOALS)" "maintainer-clean"
 
 include $(TOP)/mk/boilerplate.mk
 
@@ -18,7 +19,8 @@
 
 endif
 endif
+endif
 
 clean distclean maintainer-clean:
 	$(MAKE) -C $(TOP)/timeout $@
-
+	$(RM) -f mk/*.o mk/*.hi mk/ghc-config mk/ghc-config.exe mk/ghcconfig*.mk

=== testsuite/timeout/Makefile ===
--- 
+++ 
@@ -7,6 +7,7 @@
 # being defined.
 ifneq "$(MAKECMDGOALS)" "clean"
 ifneq "$(MAKECMDGOALS)" "distclean"
+ifneq "$(MAKECMDGOALS)" "maintainer-clean"
 
 include $(TOP)/mk/boilerplate.mk
 
@@ -58,6 +59,7 @@
 
 endif
 endif
+endif
 
 clean distclean maintainer-clean:
 	-./Setup clean

=== testsuite/tests/cabal/Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 include $(TOP)/mk/test.mk
 
 PKGCONF01=local01.package.conf
-LOCAL_GHC_PKG01 = '$(GHC_PKG)' --no-user-package-conf -f $(PKGCONF01)
+LOCAL_GHC_PKG01 = '$(GHC_PKG)' --no-user-package-db -f $(PKGCONF01)
 
 STRIP_PKGROOT=sed 's/^pkgroot: .*$$/pkgroot: /'
 
@@ -49,7 +49,7 @@
 	if $(LOCAL_GHC_PKG01) register test3.pkg; then false; else true; fi
 
 PKGCONF03=local03.package.conf
-LOCAL_GHC_PKG03 = '$(GHC_PKG)' --no-user-package-conf -f $(PKGCONF03)
+LOCAL_GHC_PKG03 = '$(GHC_PKG)' --no-user-package-db -f $(PKGCONF03)
 
 ghcpkg03 :
 	@rm -rf $(PKGCONF03)
@@ -67,7 +67,7 @@
 	$(LOCAL_GHC_PKG03) update --force test.pkg
 
 PKGCONF04=local04.package.conf
-LOCAL_GHC_PKG04 = '$(GHC_PKG)' --no-user-package-conf -f $(PKGCONF04)
+LOCAL_GHC_PKG04 = '$(GHC_PKG)' --no-user-package-db -f $(PKGCONF04)
 
 # Test that importing a module exposed by two packages reports a conflict
 ghcpkg04 :
@@ -77,13 +77,13 @@
 	$(LOCAL_GHC_PKG04) update --force test5.pkg >/dev/null 2>&1 
 	$(LOCAL_GHC_PKG04) expose testpkg-1.2.3.4  >/dev/null 2>&1
 	@: # testpkg-1.2.3.4 and newtestpkg-2.0 are both exposed now
-	'$(TEST_HC)' $(TEST_HC_OPTS) -package-conf $(PKGCONF04) -c ghcpkg04.hs || true
+	'$(TEST_HC)' $(TEST_HC_OPTS) -package-db $(PKGCONF04) -c ghcpkg04.hs || true
 
 # Test stacking of package.confs (also #2441)
 PKGCONF05a=local05a.package.conf
 PKGCONF05b=local05b.package.conf
-LOCAL_GHC_PKG05a = '$(GHC_PKG)' --no-user-package-conf -f $(PKGCONF05a)
-LOCAL_GHC_PKG05b = '$(GHC_PKG)' --no-user-package-conf -f $(PKGCONF05a) -f $(PKGCONF05b)
+LOCAL_GHC_PKG05a = '$(GHC_PKG)' --no-user-package-db -f $(PKGCONF05a)
+LOCAL_GHC_PKG05b = '$(GHC_PKG)' --no-user-package-db -f $(PKGCONF05a) -f $(PKGCONF05b)
 
 ghcpkg05 :
 	rm -rf $(PKGCONF05a) $(PKGCONF05b)
@@ -101,7 +101,7 @@
 
 # Test for #2330: reject duplicate dependencies
 PKGCONF06=local06.package.conf
-LOCAL_GHC_PKG06 = '$(GHC_PKG)' --no-user-package-conf -f $(PKGCONF06)
+LOCAL_GHC_PKG06 = '$(GHC_PKG)' --no-user-package-db -f $(PKGCONF06)
 
 ghcpkg06 :
 	rm -rf $(PKGCONF06)
@@ -111,25 +111,25 @@
 	$(LOCAL_GHC_PKG06) register --force testdup.pkg
 
 PKGCONF1750=local1750.package.conf
-LOCAL_GHC_PKG1750 = '$(GHC_PKG)' --no-user-package-conf -f $(PKGCONF1750)
+LOCAL_GHC_PKG1750 = '$(GHC_PKG)' --no-user-package-db -f $(PKGCONF1750)
 
 1750:
 	rm -rf $(PKGCONF1750) 1750.hs 1750.o 1750.hi 1750.out
 	$(LOCAL_GHC_PKG1750) init $(PKGCONF1750)
 	$(LOCAL_GHC_PKG1750) register --force 1750A.pkg >1750.out 2>&1
 	$(LOCAL_GHC_PKG1750) register --force 1750B.pkg >1750.out 2>&1
-	GHC_PACKAGE_PATH=$(PKGCONF1750) '$(GHC_PKG)' --no-user-package-conf list
+	GHC_PACKAGE_PATH=$(PKGCONF1750) '$(GHC_PKG)' --no-user-package-db list
 # GHC_PACKAGE_PATH trick is to make this work with 6.8.2 which doesn't have
 # the patch "Change the command-line semantics for query commands" to
 # ghc-pkg
 	echo "main = return ()" >1750.hs
-	'$(TEST_HC)' $(TEST_HC_OPTS) -package-conf $(PKGCONF1750) -package 1750A 1750.hs || true
+	'$(TEST_HC)' $(TEST_HC_OPTS) -package-db $(PKGCONF1750) -package 1750A 1750.hs || true
 
 PKGCONFSHADOW1=localshadow1.package.conf
 PKGCONFSHADOW2=localshadow2.package.conf
-LOCAL_GHC_PKGSHADOW1 = '$(GHC_PKG)' --no-user-package-conf -f $(PKGCONFSHADOW1)
-LOCAL_GHC_PKGSHADOW2 = '$(GHC_PKG)' --no-user-package-conf -f $(PKGCONFSHADOW2)
-LOCAL_GHC_PKGSHADOW3 = '$(GHC_PKG)' --no-user-package-conf -f $(PKGCONFSHADOW1) -f $(PKGCONFSHADOW2)
+LOCAL_GHC_PKGSHADOW1 = '$(GHC_PKG)' --no-user-package-db -f $(PKGCONFSHADOW1)
+LOCAL_GHC_PKGSHADOW2 = '$(GHC_PKG)' --no-user-package-db -f $(PKGCONFSHADOW2)
+LOCAL_GHC_PKGSHADOW3 = '$(GHC_PKG)' --no-user-package-db -f $(PKGCONFSHADOW1) -f $(PKGCONFSHADOW2)
 
 # Test package shadowing behaviour.
 #
@@ -152,18 +152,18 @@
 # shadowdep-1-XXX to be unavailable:
 #
 	@echo "should FAIL:"
-	'$(TEST_HC)' $(TEST_HC_OPTS) -package-conf $(PKGCONFSHADOW1) -package-conf $(PKGCONFSHADOW2) -package shadowdep -c shadow.hs -fno-code || true
+	'$(TEST_HC)' $(TEST_HC_OPTS) -package-db $(PKGCONFSHADOW1) -package-db $(PKGCONFSHADOW2) -package shadowdep -c shadow.hs -fno-code || true
 # 
 # Reversing the order of the package.conf files should fix the problem:
 #
 	@echo "should SUCCEED:"
-	'$(TEST_HC)' $(TEST_HC_OPTS) -package-conf $(PKGCONFSHADOW2) -package-conf $(PKGCONFSHADOW1) -package shadowdep -c shadow.hs -fno-code || true
+	'$(TEST_HC)' $(TEST_HC_OPTS) -package-db $(PKGCONFSHADOW2) -package-db $(PKGCONFSHADOW1) -package shadowdep -c shadow.hs -fno-code || true
 #
 # We can also fix the problem by using an explicit -package-id flag to
 # specify a package we really want to use:
 #
 	@echo "should SUCCEED:"
-	'$(TEST_HC)' $(TEST_HC_OPTS) -package-conf $(PKGCONFSHADOW1) -package-conf $(PKGCONFSHADOW2) -package-id shadowdep-1-XXX -c shadow.hs -fno-code
+	'$(TEST_HC)' $(TEST_HC_OPTS) -package-db $(PKGCONFSHADOW1) -package-db $(PKGCONFSHADOW2) -package-id shadowdep-1-XXX -c shadow.hs -fno-code
 
 
 # -----------------------------------------------------------------------------
@@ -172,7 +172,7 @@
 # of InstalledPackageInfo.
 
 PACKAGE_CONF_ghcpkg02 = package.conf.ghcpkg02
-GHC_PKG_ghcpkg02 = '$(GHC_PKG)' --no-user-package-conf --global-conf=$(PACKAGE_CONF_ghcpkg02)
+GHC_PKG_ghcpkg02 = '$(GHC_PKG)' --no-user-package-db --global-package-db=$(PACKAGE_CONF_ghcpkg02)
 
 ghcpkg02:
 	rm -rf $(PACKAGE_CONF_ghcpkg02)

=== testsuite/tests/dynlibs/Makefile ===
--- 
+++ 
@@ -9,7 +9,7 @@
 	$(RM) T3807-export.o T3807-load.o
 	$(RM) T3807test.so
 	$(RM) T3807-load
-	'$(TEST_HC)' $(filter-out -rtsopts,$(TEST_HC_OPTS)) -v0 --make -dynamic -fPIC -shared T3807Export.hs T3807-export.c -o T3807test.so -lHSrts-ghc`'$(TEST_HC)' $(TEST_HC_OPTS) --numeric-version` -rtsopts
+	'$(TEST_HC)' $(filter-out -rtsopts,$(TEST_HC_OPTS)) -v0 --make -dynamic -fPIC -shared T3807Export.hs T3807-export.c -o T3807test.so -lHSrts-ghc`'$(TEST_HC)' $(TEST_HC_OPTS) --numeric-version`
 	'$(TEST_HC)' $(filter-out -rtsopts,$(TEST_HC_OPTS)) -no-auto-link-packages -no-hs-main T3807-load.c -o T3807-load -ldl
 	./T3807-load
 
@@ -19,7 +19,7 @@
 	$(RM) T4464H_stub.c T4464H_stub.h T4464H_stub.o
 	$(RM) HS4464.dll HS4464.dll.a t4464.exe
 	'$(TEST_HC)' $(TEST_HC_OPTS) -v0 -shared T4464H.hs T4464B.c -optc-DRTSOPTS=RtsOptsSafeOnly -o HS4464.dll
-	'$(TEST_HC)' $(TEST_HC_OPTS) -v0 T4464C.c HS4464.dll.a -o t4464.exe -no-hs-main
+	'$(TEST_HC)' $(filter-out -rtsopts,$(TEST_HC_OPTS)) -v0 T4464C.c HS4464.dll.a -o t4464.exe -no-hs-main
 	-./t4464.exe
 	echo "====="
 	echo "=====" >&2
@@ -27,7 +27,7 @@
 	$(RM) T4464H_stub.c T4464H_stub.h T4464H_stub.o
 	$(RM) HS4464.dll HS4464.dll.a t4464.exe
 	'$(TEST_HC)' $(TEST_HC_OPTS) -v0 -shared T4464H.hs T4464B.c  -optc-DRTSOPTS=RtsOptsAll -o HS4464.dll
-	'$(TEST_HC)' $(TEST_HC_OPTS) -v0 T4464C.c HS4464.dll.a -o t4464.exe -no-hs-main
+	'$(TEST_HC)' $(filter-out -rtsopts,$(TEST_HC_OPTS)) -v0 T4464C.c HS4464.dll.a -o t4464.exe -no-hs-main
 	./t4464.exe
 
 .PHONY: T5373

=== testsuite/tests/gadt/Makefile ===
TOP=../..
include $(TOP)/mk/boilerplate.mk
include $(TOP)/mk/test.mk

.PHONY: gadt17 gadt23

# A mulit-module test that made GHC 6.4.1 crash
gadt17:
	@$(RM) gadt17.hi Gadt17_help.hi
	@$(RM) A$(OBJSUFFIX)
	'$(TEST_HC)' $(TEST_HC_OPTS) -c Gadt17_help.hs
	'$(TEST_HC)' $(TEST_HC_OPTS) -c gadt17.hs

gadt23:
	$(RM) gadt23 gadt23.hi gadt23.o Gadt23_AST.hi Gadt23_AST.o
	'$(TEST_HC)' $(TEST_HC_OPTS) -v0 --make gadt23.hs
	# We want to "touch gadt23.hs" really, but we then have issues with
	# everything happening in the same second so the touch having no
	# effect. Thus make gadt23.hi/o older instead.
	touch -t 01010000 gadt23.hi gadt23.o
	'$(TEST_HC)' $(TEST_HC_OPTS) -v0 --make gadt23.hs

=== testsuite/tests/ghc-api/Makefile ===
TOP=../..
include $(TOP)/mk/boilerplate.mk
include $(TOP)/mk/test.mk

clean:
	rm -f *.o *.hi

T6145: clean
	'$(TEST_HC)' $(TEST_HC_OPTS) --make -v0 -package ghc T6145
	./T6145 "`'$(TEST_HC)' $(TEST_HC_OPTS) --print-libdir | tr -d '\r'`"

.PHONY: clean T6145

=== testsuite/tests/hsc2hs/Makefile ===
TOP=../..
include $(TOP)/mk/boilerplate.mk
include $(TOP)/mk/test.mk

.PHONY: hsc2hs001
hsc2hs001:
	'$(HSC2HS)' $@.hsc
	'$(TEST_HC)' $(TEST_HC_OPTS) -c $@.hs

.PHONY: hsc2hs002
hsc2hs002:
	'$(HSC2HS)' $@.hsc
	'$(TEST_HC)' $(TEST_HC_OPTS) -c $@.hs

.PHONY: hsc2hs003
hsc2hs003:
	'$(HSC2HS)' $@.hsc
	'$(TEST_HC)' $(TEST_HC_OPTS) -v0 --make $@
	./$@

.PHONY: hsc2hs004
hsc2hs004:
	'$(HSC2HS)' --cross-compile $@.hsc
	'$(TEST_HC)' $(TEST_HC_OPTS) -v0 --make $@
	./$@

.PHONY: 3837
3837:
	LANG=C '$(HSC2HS)' $@.hsc
	'$(TEST_HC)' $(TEST_HC_OPTS) -c $@.hs

=== testsuite/tests/layout/Makefile ===
TOP=../..
include $(TOP)/mk/boilerplate.mk
include $(TOP)/mk/test.mk

layout001 layout002 layout003 layout004 layout005 layout006 layout007 layout008 layout009: %:
	$(RM) $*.hi $*.o
	echo Running with -XNoAlternativeLayoutRule
	-"$(TEST_HC)" $(TEST_HC_OPTS) -v0 -XNoAlternativeLayoutRule -c $*.hs 2>&1
	$(RM) $*.hi $*.o
	echo Running with -XAlternativeLayoutRule
	-"$(TEST_HC)" $(TEST_HC_OPTS) -v0 -XAlternativeLayoutRule -c $*.hs 2>&1
	$(RM) $*.hi $*.o
	echo Running with -XAlternativeLayoutRule -XAlternativeLayoutRuleTransitional
	-"$(TEST_HC)" $(TEST_HC_OPTS) -v0 -XAlternativeLayoutRule -XAlternativeLayoutRuleTransitional -c $*.hs 2>&1

=== testsuite/tests/plugins/Makefile ===
--- 
+++ 
@@ -12,8 +12,8 @@
 	#
 	# Suggestions to make this better gratefully recieved.
 	(cd simple-plugin; make package)
-	@$(RM) plugins01.hi plugins01.o
-	"$(TEST_HC)" $(HC_OPTS) --make -v0 plugins01.hs -package-conf simple-plugin/local.package.conf -fplugin Simple.Plugin -fplugin-opt Simple.Plugin:Irrelevant_Option -package simple-plugin
+	$(RM) plugins01.hi plugins01.o
+	"$(TEST_HC)" $(HC_OPTS) --make -v0 plugins01.hs -package-db simple-plugin/local.package.conf -fplugin Simple.Plugin -fplugin-opt Simple.Plugin:Irrelevant_Option -package simple-plugin
 	./plugins01
 
 clean:

=== testsuite/tests/polykinds/Makefile ===
TOP=../..
include $(TOP)/mk/boilerplate.mk
include $(TOP)/mk/test.mk

# T5881 needs a script because it goes wrong only when 
# the modules are compiled separately, not with --make
T5881:
	$(RM) -f T5881.hi T5881.o T5881a.hi T5881a.o
	'$(TEST_HC)' $(TEST_HC_OPTS) -c T5881a.hs
	'$(TEST_HC)' $(TEST_HC_OPTS) -c T5881.hs

# T6025 is like T5881; needs separate compile
T6025:
	$(RM) -f T6025.hi T6025.o T6025a.hi T6025a.o
	'$(TEST_HC)' $(TEST_HC_OPTS) -c T6025a.hs
	'$(TEST_HC)' $(TEST_HC_OPTS) -c T6025.hs

# T6054 is like T5881; needs separate compile
# The second compile fails, and should do so, hence leading "-"
T6054:
	$(RM) -f T6054.hi T6054.o T6054a.hi T6054a.o
	'$(TEST_HC)' $(TEST_HC_OPTS) -c T6054a.hs
	-'$(TEST_HC)' $(TEST_HC_OPTS) -c T6054.hs

T7022:
	$(RM) -f T7022.hi T7022.o T7022a.hi T7022a.o
	'$(TEST_HC)' $(TEST_HC_OPTS) -c T7022a.hs
	-'$(TEST_HC)' $(TEST_HC_OPTS) -c -v0 T7022.hs

=== testsuite/tests/rts/Makefile ===
--- 
+++ 
@@ -35,7 +35,7 @@
 4850:
 	$(RM) 4850.o 4850.hi 4850$(exeext)
 	"$(TEST_HC)" $(TEST_HC_OPTS) -v0 -rtsopts -debug -threaded --make 4850
-	./4850 +RTS -s 2>&1 | grep Task | wc -l | tr -d ' '
+	./4850 +RTS -s 2>&1 | grep TASKS | sed 's/^ *TASKS: *\([0-9]*\).*$$/\1/'
 
 .PHONY: T5423
 T5423:
@@ -45,3 +45,12 @@
 	"$(TEST_HC)" $(TEST_HC_OPTS) -v0 T5423.o T5423_cmm.o -o T5423$(exeext)
 	./T5423
 
+T6006_setup :
+	'$(TEST_HC)' $(TEST_HC_OPTS) -c T6006.hs
+
+.PHONY: T7037
+T7037:
+	$(RM) 7037.o 7037.hi 7037$(exeext)
+	"$(TEST_HC)" $(TEST_HC_OPTS) T7037.hs -v0
+	"$(TEST_HC)" $(filter-out -rtsopts, $(TEST_HC_OPTS)) T7037_main.c -v0 -o T7037_main -no-hs-main
+	./T7037_main

=== debian/changelog ===
ghc-testsuite (7.6.3-1) unstable; urgency=low

  * New upstream release 

 -- Joachim Breitner <nomeata@debian.org>  Sun, 26 May 2013 18:59:23 +0200

ghc-testsuite (7.6.1.20121207-2) unstable; urgency=low

  * Enable compat level 9

 -- Joachim Breitner <nomeata@debian.org>  Fri, 24 May 2013 12:49:44 +0200

ghc-testsuite (7.6.1.20121207-1) experimental; urgency=low

  * New upstream release (7.6.2-rc1)
  * Use QuickCheck version 2 

 -- Joachim Breitner <nomeata@debian.org>  Sun, 06 Jan 2013 11:50:48 +0100

ghc-testsuite (7.6.1-1) experimental; urgency=low

  * Bump standards version, no change
  * New upstream release 

 -- Joachim Breitner <nomeata@debian.org>  Fri, 09 Nov 2012 21:14:31 +0100

=== debian/control ===
--- 
+++ 
@@ -5,13 +5,13 @@
 Uploaders: Joachim Breitner <nomeata@debian.org>
 Build-Depends:
  python,
- debhelper (>= 8.0.0),
- ghc (>= 7.4.2),
- ghc (<< 7.4.2+),
+ debhelper (>= 9),
+ ghc (>= 7.6.3),
+ ghc (<< 7.6.3+),
  ghc-prof,
  ghc-dynamic [i386 amd64],
- libghc-quickcheck1-dev,
- libghc-quickcheck1-prof,
+ libghc-quickcheck2-dev,
+ libghc-quickcheck2-prof,
  libghc-vector-dev,
  libghc-vector-prof,
  libghc-mtl-dev,
@@ -28,7 +28,7 @@
  libghc-utf8-string-prof,
  libghc-parsec3-dev,
  libghc-parsec3-prof,
-Standards-Version: 3.9.2
+Standards-Version: 3.9.4
 Homepage: http://hackage.haskell.org/trac/ghc/wiki/Building/RunningTests
 Vcs-Darcs: http://darcs.debian.org/pkg-haskell/ghc-testsuite
 Vcs-Browser: http://darcs.debian.org/cgi-bin/darcsweb.cgi?r=pkg-haskell/ghc-testsuite

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ 

override_dh_auto_build:
	cp -al testsuite testsuite-run
	# Does not seem to work:
	# OUTPUT_SUMMARY="$(CURDIR)/debian/ghc-testsuite/usr/share/doc/ghc-testsuite/result.txt" 
	make -C testsuite-run \
		SKIPWAY="" \
		fast=YES \
		2>&1 | tee result.txt

override_dh_auto_install:
	mkdir -p debian/ghc-testsuite/usr/share/doc/ghc-testsuite
	cp result.txt "$(CURDIR)/debian/ghc-testsuite/usr/share/doc/ghc-testsuite/result.txt"

override_dh_auto_clean:
	rm -rf testsuite-run
	rm -f result.txt

=== debian/watch ===
version=3
http://haskell.org/ghc/dist/([\d.]+)/ghc-([\d.]+)-testsuite.tar.bz2

## ghc-testsuite 7.8.4

=== debian/changelog ===
ghc-testsuite (7.8.4-1) unstable; urgency=medium

  * Team upload
  [ Joachim Breitner ]
  * Fix watchfile 
  [ Gianfranco Costamagna]
  * Conflict with ghc <> 7.8.4
  * New upstream release 
  * Bump std-version to 3.9.6, no changes
  * Remove ghc-dynamic build dependency.

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Wed, 13 May 2015 12:19:21 +0200

=== debian/control ===
--- 
+++ 
@@ -6,10 +6,9 @@
 Build-Depends:
  python,
  debhelper (>= 9),
- ghc (>= 7.6.3),
- ghc (<< 7.6.3+),
+ ghc (>= 7.8.4),
+ ghc (<< 7.8.4+),
  ghc-prof,
- ghc-dynamic [i386 amd64],
  libghc-quickcheck2-dev,
  libghc-quickcheck2-prof,
  libghc-vector-dev,
@@ -28,7 +27,7 @@
  libghc-utf8-string-prof,
  libghc-parsec3-dev,
  libghc-parsec3-prof,
-Standards-Version: 3.9.4
+Standards-Version: 3.9.6
 Homepage: http://hackage.haskell.org/trac/ghc/wiki/Building/RunningTests
 Vcs-Darcs: http://darcs.debian.org/pkg-haskell/ghc-testsuite
 Vcs-Browser: http://darcs.debian.org/cgi-bin/darcsweb.cgi?r=pkg-haskell/ghc-testsuite
